hxt-9.3.1.1: A collection of tools for processing XML with Haskell.

Portability | non-portable
Stability | experimental
Maintainer | Uwe Schmidt (uwe\@fh-wedel.de)
Safe Haskell | Safe-Inferred

Control.Arrow.ArrowNF

Description

Arrows for evaluation of normal form results

Synopsis

- strictA :: (Arrow a, NFData b) => a b b
- class Arrow a => ArrowNF a where
  - rnfA :: NFData c => a b c -> a b c
- class (Arrow a, ArrowList a) => ArrowWNF a where
  - rwnfA :: WNFData c => a b c -> a b c
  - rwnf2A :: WNFData c => a b c -> a b c

# Documentation

strictA :: (Arrow a, NFData b) => a b bSource

complete evaluation of an arrow result using `DeepSeq`

this is sometimes useful for preventing space leaks, especially after reading and validation of a document, all DTD stuff is not longer in use and can be recycled by the GC.

class Arrow a => ArrowNF a where Source

Methods

rnfA :: NFData c => a b c -> a b cSource

Instances

ArrowNF LA |
ArrowNF IOLA |
ArrowNF (SLA s) |
ArrowNF (IOSLA s) |

class (Arrow a, ArrowList a) => ArrowWNF a where Source

partial evaluation of an arrow result using `FlatSeq`

There are tow arrows with force the partial evaluation. By convention the 2. should be less lazy than the 1.

These arrows are sometimes useful for preventing space leaks, especially when parsing complex data structures. In many cases the evaluated AST is more space efficient than the unevaluaded with a lot of closures.

Methods

rwnfA :: WNFData c => a b c -> a b cSource

rwnf2A :: WNFData c => a b c -> a b cSource

Instances

ArrowWNF LA |
ArrowWNF IOLA |
ArrowWNF (SLA s) |
ArrowWNF (IOSLA s) |